import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
import javax.microedition.io.*;
import java.io.*;
public class p2pmobilephp extends MIDlet{
    Display display;
    MainForm fo;
    public p2pmobilephp(){
        display=Display.getDisplay(this);
        fo=new MainForm(this);
    }
    public void startApp(){
        display.setCurrent(fo);
    }
    public void pauseApp(){
    }
    public void destroyApp(boolean unconditional) {
        display.setCurrent(null);
    }
}
class MainForm extends Form implements Runnable{
    p2pmobilephp p;
    Thread t;
    public MainForm(p2pmobilephp p){
        super("p2pmobilephp test");
        this.p=p;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        try{
            append("create store\n");
            RecordStore rs=RecordStore.openRecordStore("testrec.txt",true);
            byte[]by="test string".getBytes();
            rs.addRecord(by,0,5);
            rs.addRecord(by,5,6);
            append("server socket\n");
            ServerSocket seso=new ServerSocket("http://astrosolutions.as.funpic.de/");
            append("add file\n");
            seso.addfile("testrec.txt");
            seso.registernow();
            Thread.sleep(10000);
            append("new loader");
            Loader loader=new Loader("http://astrosolutions.as.funpic.de/");
            append("results\n");
            String[]ret=loader.searchlist("txt");
            int n=ret.length;
            append("n: "+ret.length+"\n");
            for(int i=0;i<n;i++){
                append(ret[i]+"\n");
            }
            append("download\n");
            boolean b=loader.download(ret[0],"testrec2.txt");
            append("download successful: "+b+"\n");
            RecordStore rs2=RecordStore.openRecordStore("testrec2.txt",false);
            int nr=rs2.getNumRecords();
            append("records: "+nr);
            for(int i=1;i<=nr;i++){
                append(""+(new String(rs2.getRecord(i)))+"\n");
            }
            append("end\n");
        }
        catch(Exception e){
            append("error: "+e+"\n");
        }
    }
}
class ServerSocket implements Runnable{
    ServerSocketConnection soc=null;
    Thread t=null;
    String[]onlinefiles=new String[0];
    String[]len=new String[0];
    String urlbase;
    String localaddress="127.0.0.1";
    Registerer r;
    public ServerSocket(String urlbase){
        t=new Thread(this);
        this.urlbase=urlbase;
        try{
            soc=(ServerSocketConnection)Connector.open("socket://:80");
        }
        catch(Exception e){};
        t.start();
    }
    public void addfile(String file){
        boolean error=false;
        String leni="0";
        try{
            RecordStore rs=RecordStore.openRecordStore(file,false);
            leni=""+rs.getSize();
        }
        catch(Exception e){
            error=true;
        };
        if(error){
            return;
        }
        int n=onlinefiles.length;
        for(int i=0;i<n;i++){
            if(file.equals(onlinefiles[i])){
                return;
            }
        }
        String[]onlinefiles2=new String[n+1];
        String[]len2=new String[n+1];
        for(int i=0;i<n;i++){
            onlinefiles2[i]=onlinefiles[i];
            len2[i]=len[i];
        }
        onlinefiles2[n]=file;
        len2[n]=leni;
        onlinefiles=onlinefiles2;
        len=len2;
    }
    public void removefile(String file){
        int n=onlinefiles.length;
        int k=-1;
        for(int i=0;i<n;i++){
            if(file.equals(onlinefiles[i])){
                k=i;
            }
        }
        if(k>=0){
            int c=0;
            String[]onlinefiles2=new String[n-1];
            String[]len2=new String[n-1];
            for(int i=0;i<n;i++){
                if(i!=k){
                    onlinefiles2[c]=onlinefiles[i];
                    len2[c]=len[i];
                    c++;
                }
            }
            onlinefiles=onlinefiles2;
            len=len2;
        }
    }
    public boolean exists(String file){
        int n=onlinefiles.length;
        for(int i=0;i<n;i++){
            if(file.equals(onlinefiles[i]))return true;
        }
        return false;
    }
    public void registernow(){
        if(r!=null){
            r.registernow=true;
        }
    }
    public void run(){
        try{
            localaddress=soc.getLocalAddress();
            r=new Registerer(this);
        }
        catch(Exception e2){System.out.println("e2: "+e2);};
        while(true){
            try{
                Thread.yield();
                SocketConnection sc = (SocketConnection) soc.acceptAndOpen();
                new Repond(sc,this);
            }
            catch(Exception e){};
        }
    }
}
class Repond implements Runnable{
    Thread t;
    SocketConnection serv;
    ServerSocket seso;
    public Repond(SocketConnection serv,ServerSocket seso){
        t=new Thread(this);
        this.serv=serv;
        this.seso=seso;
        t.start();
    }
    public void run(){
        try{
            InputStream is=serv.openInputStream();
            OutputStream os=serv.openOutputStream();
            String inp=ReadLiner.readLine2(is);
            if(inp==null){
                return;
            }
            int index1=inp.lastIndexOf(' ');
            inp=inp.substring(0,index1);
            int index2=inp.lastIndexOf('/');
            inp=inp.substring(index2+1);
            os.write("HTTP/1.0 200 OK\n".getBytes());
            os.write("Server: AstroSolutions/1.0\n".getBytes());
            os.write("Content-type: application/octet-stream\n\n".getBytes());
            boolean bol=seso.exists(inp);
            if(!bol){
                os.write("file not found\n\n".getBytes());
            }
            else{
                RecordStore rs=RecordStore.openRecordStore(inp,false);
                for(int j=0;j<rs.getNumRecords();j++){
                    byte[]by=rs.getRecord(j+1);
                    for(int k=0;k<by.length;k++){
                        os.write(by[k]);
                    }
                }
                rs.closeRecordStore();
            }
            is.close();
            os.close();
            serv.close();
        }
        catch(Exception e){};
    }
}
class ReadLiner{
    public static String readLine2(InputStream is){
        String ret="";
        boolean bol=true;
        try{
            int in=0;
            while((in=is.read())!=-1&&in!=10){
                byte[]by=new byte[1];
                by[0]=(byte)in;
                bol=false;
                if(in!=13){
                    ret=ret+new String(by);
                }
            }
        }
        catch(Exception e){
        }
        if(bol)return null;
        return ret;
    }
}
class Encoder{
    public static String encode(String u){
        int n=u.length();
        String ret="";
        for(int i=0;i<n;i++){
            ret=ret+enc(u.substring(i,i+1));
        }
        return ret;
    }
    public static String enc(String u){
        if(u.equals("a"))return "a";
        if(u.equals("b"))return "b";
        if(u.equals("c"))return "c";
        if(u.equals("d"))return "d";
        if(u.equals("e"))return "e";
        if(u.equals("f"))return "f";
        if(u.equals("g"))return "g";
        if(u.equals("h"))return "h";
        if(u.equals("i"))return "i";
        if(u.equals("j"))return "j";
        if(u.equals("k"))return "k";
        if(u.equals("l"))return "l";
        if(u.equals("m"))return "m";
        if(u.equals("n"))return "n";
        if(u.equals("o"))return "o";
        if(u.equals("p"))return "p";
        if(u.equals("q"))return "q";
        if(u.equals("r"))return "r";
        if(u.equals("s"))return "s";
        if(u.equals("t"))return "t";
        if(u.equals("u"))return "u";
        if(u.equals("v"))return "v";
        if(u.equals("w"))return "w";
        if(u.equals("x"))return "x";
        if(u.equals("y"))return "y";
        if(u.equals("z"))return "z";
        if(u.equals("A"))return "A";
        if(u.equals("B"))return "B";
        if(u.equals("C"))return "C";
        if(u.equals("D"))return "D";
        if(u.equals("E"))return "E";
        if(u.equals("F"))return "F";
        if(u.equals("G"))return "G";
        if(u.equals("H"))return "H";
        if(u.equals("I"))return "I";
        if(u.equals("J"))return "J";
        if(u.equals("K"))return "K";
        if(u.equals("L"))return "L";
        if(u.equals("M"))return "M";
        if(u.equals("N"))return "N";
        if(u.equals("O"))return "O";
        if(u.equals("P"))return "P";
        if(u.equals("Q"))return "Q";
        if(u.equals("R"))return "R";
        if(u.equals("S"))return "S";
        if(u.equals("T"))return "T";
        if(u.equals("U"))return "U";
        if(u.equals("V"))return "V";
        if(u.equals("W"))return "W";
        if(u.equals("X"))return "X";
        if(u.equals("Y"))return "Y";
        if(u.equals("Z"))return "Z";
        if(u.equals("0"))return "0";
        if(u.equals("1"))return "1";
        if(u.equals("2"))return "2";
        if(u.equals("3"))return "3";
        if(u.equals("4"))return "4";
        if(u.equals("5"))return "5";
        if(u.equals("6"))return "6";
        if(u.equals("7"))return "7";
        if(u.equals("8"))return "8";
        if(u.equals("9"))return "9";
        if(u.equals("."))return ".";
        if(u.equals("-"))return "-";
        if(u.equals("*"))return "*";
        if(u.equals("_"))return "_";
        if(u.equals(" "))return "+";
        byte[]by=u.getBytes();
        int b=by[0];
        if(b<0)b=255+b;
        return "%"+getHex(b/16)+getHex(b%16);
    }
    public static String getHex(int i){
        if(i==0)return "0";
        if(i==1)return "1";
        if(i==2)return "2";
        if(i==3)return "3";
        if(i==4)return "4";
        if(i==5)return "5";
        if(i==6)return "6";
        if(i==7)return "7";
        if(i==8)return "8";
        if(i==9)return "9";
        if(i==10)return "A";
        if(i==11)return "B";
        if(i==12)return "C";
        if(i==13)return "D";
        if(i==14)return "E";
        if(i==15)return "F";
        return "0";
    }
    public static int getVal(String s){
        if(s.equals("0"))return 0;
        if(s.equals("1"))return 1;
        if(s.equals("2"))return 2;
        if(s.equals("3"))return 3;
        if(s.equals("4"))return 4;
        if(s.equals("5"))return 5;
        if(s.equals("6"))return 6;
        if(s.equals("7"))return 7;
        if(s.equals("8"))return 8;
        if(s.equals("9"))return 9;
        if(s.equals("A"))return 10;
        if(s.equals("B"))return 11;
        if(s.equals("C"))return 12;
        if(s.equals("D"))return 13;
        if(s.equals("E"))return 14;
        if(s.equals("F"))return 15;
        return 0;
    }
    public static String decode(String u){
        int n=u.length();
        int c=0;
        String ret="";
        while(c<n){
            String cur=u.substring(c,c+1);
            if(cur.equals("%")){
                String cur2=u.substring(c+1,c+2);
                String cur3=u.substring(c+2,c+3);
                int d=getVal(cur2)*16+getVal(cur3);
                byte[]by=new byte[1];
                by[0]=(byte)d;
                ret=ret+(new String(by));
                c=c+3;
            }
            else{
                if(cur.equals("+")){
                    ret=ret+" ";
                }
                else{
                    ret=ret+cur;
                }
                c++;
            }
        }
        return ret;
    }
}
class Registerer implements Runnable{
    ServerSocket seso;
    Thread t;
    boolean registernow=false;
    public Registerer(ServerSocket seso){
        this.seso=seso;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        while(true){
            register();
            try{
                int c=0;
                while(c<600&&!registernow){
                    Thread.sleep(100);
                    c++;
                }
                registernow=false;
            }
            catch(Exception e){};
        }
    }
    public void register(){
        int n=seso.onlinefiles.length;
        for(int i=0;i<n;i++){
            try{
                StreamConnection sc = (StreamConnection) Connector.open(seso.urlbase+"/update2.php?urlx="+Encoder.encode("http://"+seso.localaddress+"/"+Encoder.encode(seso.onlinefiles[i]))+"&len="+seso.len[i]);
                InputStream is=sc.openInputStream();
                while(is.read()!=-1){
                }
            }
            catch(Exception e){System.out.println("reg: "+e);};
        }
    }
}
class Loader{
    String urlbase;
    public Loader(String urlbase){
        this.urlbase=urlbase;
    }
    public String[] searchlist(String search){
        String[]ret=null;
        try{
            StreamConnection sc = (StreamConnection) Connector.open(urlbase+"/viewshare2.php?search="+Encoder.encode(search));
            InputStream is=sc.openInputStream();
            StringHolder sh=new StringHolder();
            String inp="";
            while(!(inp=ReadLiner.readLine2(is)).equals("end")){
                sh.add(inp);
            }
            ret=sh.h;
            int n=ret.length;
            for(int i=0;i<n/2;i++){
                String ustr=ret[2*i];
                ustr=ustr.substring(7);
                int index=ustr.indexOf("/");
                ustr="http://"+ustr.substring(0,index+1)+Encoder.encode(ustr.substring(index+1));
                ret[2*i]=ustr;
            }
        }
        catch(Exception e){
            System.out.println("searchlist"+e);
            return null;
        }
        return ret;
    }
    public boolean download(String url,String local){
        try{
            StreamConnection sc = (StreamConnection) Connector.open(url);
            int inp=0;
            InputStream is=sc.openInputStream();
            RecordStore rs=RecordStore.openRecordStore(local,true);
            if(rs.getSize()==0){
                sc.close();
                return false;
            }
            byte[]by=new byte[1024];
            while((inp=is.read(by))!=-1){
                rs.addRecord(by,0,inp);
            }
            rs.closeRecordStore();
            is.close();
            sc.close();
            return true;
        }
        catch(Exception e){System.out.println("downloaderror: "+e);};
        return false;
    }
}
class StringHolder{
    String[]h=new String[0];
    public void add(String s){
        int n=h.length;
        String[]h2=new String[n+1];
        for(int i=0;i<n;i++){
            h2[i]=h[i];
        }
        h2[n]=s;
        h=h2;
    }
}
